/***************************************************************************
 FILE: com_if.c
 LVU : 0.1.0

 DESC:
 This contains the code for the IF & ELSE commands plus a dummy function
 for AND, OR & XOR.

 Copyright (C) Neil Robertson 1999
 ***************************************************************************/

#include "globals.h"


/*** IF command ***/
int com_if(int com, int *pc)
{
int pc2,nesting,ret,res;

if (pword[*pc].end - *pc < 1) return ERR_SYNTAX;

/* If expression is true continue to next line else find ELSE or FI and
   continue there */
pc2=pword[*pc].end+1;
if ((ret=evaluate_complete_boolean(*pc+1,&res))!=OK) return ret;
if (res) {  *pc=pc2;  return OK;  }

nesting=0;
for(;pword[pc2].com!=ENDPROC;pc2=pword[pc2].end+1) {
	switch(pword[pc2].com) {
		case IF: nesting++;  continue;

		case ELSE: 
		if (nesting) continue;
		goto CONT;

		case FI: 
		if (!nesting--) goto CONT;
		}
	}
return ERR_INTERNAL;

CONT:
if (pword[pc2].end != pc2) return ERR_SYNTAX;
*pc=pword[pc2].end+1;
cleardown_lw_stacks(*pc);
return OK;
}



/*** We've hit an ELSE so jump to the FI ***/
int com_else(int com, int *pc)
{
int pc2,nesting;

if (pword[*pc].end != *pc) return ERR_SYNTAX;

/* Find FI and jump to it */
nesting=0;
for(pc2=pword[*pc].end+1;pword[pc2].com!=ENDPROC;pc2=pword[pc2].end+1) {
	switch(pword[pc2].com) {
		case IF: nesting++;  continue;

		case FI: 
		if (!nesting--) {
			if (pword[pc2].end != pc2) return ERR_SYNTAX;	
			*pc=pword[pc2].end+1;
			cleardown_lw_stacks(*pc);
			return OK;
			}
		}
	}
return ERR_INTERNAL;
}



/*** AND, OR and XOR should not be a main command. They're a sub command
     which appears in boolean expressions. ***/
int com_bool(int com, int pc)
{
return ERR_UNEXPECTED_COMMAND;
}

