/***************************************************************************
 FILE: regexp.c
 LVU : 0.9.0

 DESC:
 Contains the regular expression test and parsing functions. Only a small
 subset of regular expressions are supported involving the '?', '*', '^', 
 '[...]' and '{...} operators. This code is virtually impossible to understand,
 even I forget how some of it works and I wrote it! Also it doesn't work
 properly. Oh well.

 Copyright (C) Neil Robertson 1999
 ***************************************************************************/

#include "globals.h"


/*** Returns YES if string is a regular expression pattern ***/
int is_regexp(char *str)
{
int escaped=0;

for(;*str;++str) {
	if (*str=='\\') escaped=1;
	else
	if (!escaped && strchr(REGEXP_CHARS,*str))
		return YES;
	else 
	escaped=0;
	}
return NO;
}



/*** Match wildcards and simple range regular expressions ***/
int regexp_match(char *str, char *pat)
{
char *s,*s2,*p,*rs,*re,*starpos;
int escaped,cnt,prev_cnt;

/* Attempt to match empty or null strings */
if (str==NULL) return (pat==NULL || !strlen(pat));
if (pat==NULL) return (str==NULL || !strlen(str));

s=str;
p=pat;
rs=NULL;
re=NULL;
starpos=NULL;
escaped=0;
cnt=0;
prev_cnt=0;

/* Loop through string to be matched to pattern */
while(*s) {
	switch(*p) {
		case '\0': 
		/* If we've hit the end of the pattern go back to just after
		   the last star if there was one */
		if (starpos) p=starpos+1;
		else 
		if (*(p-1)!='}') return 0;
		break; 

		case '?': 
		if (starpos) goto DEF; /* Ugh , ugly kludge or what? */
		if (!escaped) { 
			prev_cnt=cnt;
			if (!prev_cnt) cnt=regexp_get_count(p+1);
			cnt-=(cnt > 0);
			p+=(!cnt);  
			break; 
			}
		/* Fall through */

		case '*': 
		if (!escaped) {
			starpos=p;
			p++;
			if (s==str && p==pat+1) s--;
			break;
			}
		/* Fall through */

		case '[':
		if (!escaped) {  
			regexp_get_range(p,&rs,&re);  
			--s;  
			p++;
			break; 
			}
		/* Fall through */

		case '{':
		if (starpos) goto DEF;
		if (!escaped) {
			while(*p && *p++!='}');  
			--s;
			prev_cnt=0;
			cnt=0;
			break;
			}

		case '\\': 
		if (!escaped) {  escaped=1;  --s;  ++p;  break;  }
		/* Fall through */


		default:
		if (starpos) {
			DEF:
			if ((!escaped && *p=='{') || 
			    !regexp_charmatch(*s,*p,escaped,rs,re)) {
				if (!escaped && *p=='{') {
					cnt=regexp_get_count(p);
					s2=s-1;
					while(cnt) {
						if (!regexp_charmatch(*s2,*(p-1),escaped,rs,re)) 
							break;
						++s2;
						--cnt;
						}
					if (!cnt) {
						rs=NULL;
						re=NULL;
						while(*p && *p++!='}'); 
						++p;
						s=s2;
						escaped=0;  
						prev_cnt=0;
						break;
						}
					cnt=0;
					}
				p=starpos+1;
				if (*p=='[') regexp_get_range(p,&rs,&re); 
				if (regexp_charmatch(*s,*p,escaped,rs,re) && 
				    *s==*(s-1)) s--;
				}	
			else 
			if (rs) {
				p=re+2;
				if (*p!='{') rs=NULL,re=NULL;
				}
			else p++;
			escaped=0;
			break;
			}
		if (!regexp_charmatch(*s,*p,escaped,rs,re)) return 0;
		if (!prev_cnt) {
			if (rs) cnt=regexp_get_count(re+2); 
			else cnt=regexp_get_count(p+1); 
			}
		prev_cnt=cnt;
		cnt-=(cnt > 0);
		
		if (rs) {
			if (!cnt) p=re+2;  else p=rs-1;
			}
		else p+=(!cnt);

		escaped=0;
		rs=NULL;
		re=NULL;
		}
	++s;
	}
/* If {..} is on end of pattern we might have reached end of compare
   string first */
if (*p=='{') while(*p && *p++!='}');  

/* Only return 1 if we're at the end of the pattern or '*' is at the end */
if (*p) return (*p=='*' && !*(p+1)); 
return 1;
}



/*** Match c1 against c2 or against the range between rs and re ***/
int regexp_charmatch(
	char c1,
	char c2,
	int escaped,
	char *rs,
	char *re)
{
char *s;
int not;

if (rs==NULL) return (c1==c2 || (c2=='?' && !escaped));
if (*re=='[') return 0; /* Empty range */

if (*rs=='^') not=1,++rs;
else not=0;

for(s=rs;s <= re;++s) {
	/* See if we've got an actual range */
	if (*(s+1)=='-' && *(s+2)!=']') {
		if (c1 >= *s && c1 <= *(s+2)) return !not;
		s=s+2;
		}
	else
	if (c1==*s) return !not;
	}
return not;
}



/*** Get the start and end points of a range between [ and ] ***/
void regexp_get_range(char *p, char **rs, char **re)
{
int escaped=0;

*rs=p+1;
for(*re=*rs;**re;++(*re)) {
	if (**re==']' && !escaped) break;
	escaped=(**re=='\\');
	}
if (**re==']') (*re)--; else *rs=NULL,*re=NULL;
}



/*** Get count between { and } ***/
int regexp_get_count(char *p)
{
char *ps;
int cnt;

if (*p++!='{') return 0;
ps=p;
while(*p && *p!='}') ++p;
if (!*p) return 0;
*p='\0';
cnt=atoi(ps);
*p='}';
return cnt;
}
